/**
 * @file
 * Contains definition of the behaviour Animate.css.
 */

(function ($, Drupal, drupalSettings, once) {
  "use strict";

  Drupal.behaviors.textimateAdmin = {
    attach: function (context, settings) {

      if (once('textimate__sample', '.textimate__sample').length) {
        let effectSample = $('p.textimate__sample')
          , effectReplay = $('input.textimate__replay');

        // Textimate preview replay.
        effectReplay.bind('click', function (event) {
          let options = {
            selector: effectSample,
            autoStart: TRUE,
            loop: $('.textimate-loop').is(':checked'),
            minDisplayTime: $('.textimate-display-time').val(),
            initialDelay: $('.textimate-initial-delay').val(),
            // custom set of effects. This effects whether the
            // character is shown/hidden before or after an animation.
            effects: [{
              name: $('.textimate-effect').val(),
              delayScale: $('.textimate-delay-scale').val(),
              delay: $('.textimate-delay').val(),
              sync: $('.textimate-mode').val() === 'sync',
              shuffle: $('.textimate-mode').val() === 'shuffle',
              reverse: $('.textimate-mode').val() === 'reverse',
            }],
            type: $('.textimate-split').val(),
            event: $('.textimate-event').val(),
          };

          setTimeout(function () {
            Drupal.textimate(options);
          }, 10);

          event.preventDefault();
        }).trigger('click');
      }

    }
  };

})(jQuery, Drupal, drupalSettings, once);
